568 Maximum Vacation Days

1. Question

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

  1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on

    Monday.

  2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called

    flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j,

    flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.

  3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day

    and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.

  4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days

    representing this relationship. For the value of days[i][j] , it represents the maximum days you could take vacation in the city

    i in the week j.

You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

Example 1:

Input:
flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]

Output: 12

Explanation:
Ans = 6 + 3 + 3 = 12. 

One of the best strategies is:
1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day. 

(Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 
2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days.
3rd week : stay at city 2, and play 3 days and work 4 days.

Example 2:

Input:
flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]

Output: 3

Explanation:

Ans = 1 + 1 + 1 = 3. 


Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks. 

For each week, you only have one day to play and six days to work. 

So the maximum number of vacation days is 3.

Example 3:

Input:
flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]

Output: 21

Explanation:
Ans = 7 + 7 + 7 = 21

One of the best strategies is:
1st week : stay at city 0, and play 7 days. 
2nd week : fly from city 0 to city 1 on Monday, and play 7 days.
3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

Note:

  1. N and K are positive integers, which are in the range of [1, 100].

  2. In the matrix flights , all the values are integers in the range of [0, 1].

  3. In the matrix days, all the values are integers in the range [0, 7].

  4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.

  5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.

  6. We don't consider the impact of flight hours towards the calculation of vacation days.

2. Implementation

(1) DFS (Brute Force)

class Solution {
    public int maxVacationDays(int[][] flights, int[][] days) {
        int N = flights.length;
        int K = days[0].length;

        return getMaxVacations(0, 0, N, K, flights, days);
    }

    public int getMaxVacations(int week, int city, int N, int K, int[][] flights, int[][] days) {
        if (week == K) {
            return 0;
        } 

        int maxVacations = 0;
        int vacations = 0;

        for (int nextCity = 0; nextCity < N; nextCity++) {
            if (nextCity == city || flights[city][nextCity] == 1) {
                vacations = days[nextCity][week] + getMaxVacations(week + 1, nextCity, N, K, flights, days);
                maxVacations = Math.max(maxVacations, vacations);
            }
        }
        return maxVacations;
    }
}

(2) DFS + Memoization

这个问题存在overlapping subproblem, 将算法按照(city, week)的形式化成树模型可以看出有重复子问题,所以需要memoization

class Solution {
    public int maxVacationDays(int[][] flights, int[][] days) {
        int N = flights.length;
        int K = days[0].length;
        int[][] cache = new int[N][K];

        return getMaxVacations(0, 0, N, K, cache, flights, days);
    }

    public int getMaxVacations(int week, int city, int N, int K, int[][] cache, int[][] flights, int[][] days) {
        if (week == K) {
            return 0;
        } 

        if (cache[city][week] != 0) {
            return cache[city][week];
        }

        int maxVacations = 0;
        int vacations = 0;

        for (int nextCity = 0; nextCity < N; nextCity++) {
            if (nextCity == city || flights[city][nextCity] == 1) {
                vacations = days[nextCity][week] + getMaxVacations(week + 1, nextCity, N, K, cache, flights, days);
                maxVacations = Math.max(maxVacations, vacations);
            }
        }
        cache[city][week] = maxVacations;
        return maxVacations;
    }
}

(3) DP

class Solution {
    public int maxVacationDays(int[][] flights, int[][] days) {
        int N = flights.length;
        int K = days[0].length;
        // dp[i][j] means the maximum vacations we can get in city i at week j
        int[][] dp = new int[N][K];
        // canReach[i][j] checks whether we can reach city i at week j, we need this table since we will check the max vacations
        // we can get the last week from each city based on the value in dp[][] table. Since we always start at city 0 at the
        // first week, it is meaningless to check max vacations at the last week in city i if we can not get to that city
        boolean[][] canReach = new boolean[N][K];

        for (int city = 0; city < N; city++) {
            if (city == 0 || flights[0][city] == 1) {
                dp[city][0] = days[city][0];
                canReach[city][0] = true;
            }
        }

        for (int week = 1; week < K; week++) {
            for (int curCity = 0; curCity < N; curCity++) {
                for (int preCity = 0; preCity < N; preCity++) {
                    if (canReach[preCity][week - 1] && (preCity == curCity || flights[preCity][curCity] == 1)) {
                        dp[curCity][week] = Math.max(dp[curCity][week], days[curCity][week] + dp[preCity][week - 1]);
                        canReach[curCity][week] = true;
                    }
                }
            }
        }

        // Check the max vacations we can get in the last week from each city
        int res = 0;
        for (int city = 0; city < N; city++) {
            res = Math.max(res, dp[city][K - 1]);
        }
        return res;
    }
}

3. Time & Space Complexity

DFS (Brute Force): 时间复杂度O(N ^ K), 递归树的深度是K, 递归树的每个节点最多有N个branch, 空间复杂度O(K),递归树的深度是K

DFS + Memoization: 时间复杂度O(KN^2), 我们需要fill up size为NK的memoization table, 而每个cell需要O(N)时间, 空间复杂度O(NK), memoinzation的数组size

DP: 时间复杂度O(KN^2), 空间复杂度O(NK)

Last updated